/**************************************************************

imglist.h (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef IMGLIST_H
#define IMGLIST_H

typedef void* tImgList;

tImgList ImgList_Create(int extra_long, int extra_dbl);
     /* Initialize the variables */
void ImgList_Destroy(tImgList list);
     /* Clear image list and free allocated memory */
int  ImgList_Add(tImgList list, void *ccd);
     /* Add image into the list */
void ImgList_Clear(tImgList list);
     /* Clear image list */
int  ImgList_Count(tImgList list);
     /* Returns number of images in the list */
int  ImgList_First(tImgList list);
     /* Sets the pointer to first image */
int  ImgList_Next(tImgList list);
     /* Sets the pointer to next image */
int  ImgList_SetImage(tImgList list, void *ccd);
     /* Writes the current image and increments the counter */
void *ImgList_GetImage(tImgList list);
     /* Reads the current image and increments the counter */
int  ImgList_SetLong(tImgList list, int index, long data);
     /* Writes user data value of current image */
long ImgList_GetLong(tImgList list, int index);
     /* Reads user data value of current image */
int  ImgList_SetDouble(tImgList list, int index, double value);
     /* Writes user data value of current image */
double ImgList_GetDouble(tImgList list, int index);
     /* Reads user data value of current image */
 
#endif
