/**************************************************************

inifile.h (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef INIFILE_H
#define INIFILE_H

typedef void inifile;

inifile *iniopen(const char *filepath1, const char *filename2);
     // Opens a file and reads it to memory. FilePath1 specifies custom parameter file specified via
     // parameter (may include the path). FileName2 specifies name of parameter file, which is used
     // only if the filepath1 was NULL or empty string. On Windows, parameter file must be located in
     // the same directory as executable. On UNIX system, the program first looks in ~/.cmunipack, and
     // when fails, looks to /etc/cmunipack directory and before opening, makes copy of this file to
     // user's home ~/.cmunipack.
void iniclos(inifile *inifile);
     // Frees allocated memory
char *inigkys(inifile *inifile, const char *key, const char *def);
double inigkyd(inifile *inifile, const char *key, double def);
long inigkyl(inifile *inifile, const char *key, long def);
     // Returns the value of parameter (string/double/int)
void inirset(inifile *inifile);
     // Sets pointer to the first parameter
int  ininkey(inifile *inifile);
     // Returns number of parameters
int  iniread(inifile *inifile, char **keyname, char **keyval, char **comment);
     // Sequential read of parametrs

#endif
