/**************************************************************

phfun.c (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h> 

#include "comfun.h"
#include "phot.h"
#include "phfun.h"

StarType *ph_first; 
StarType *ph_last;
StarType *ph_current;
int       ph_nstar;
ImageType ph_image;

void InitStarList()
{
 ph_first = NULL;
 ph_last  = NULL;
 ph_current = NULL;
 ph_nstar = 0;
}

void ClearStarList()
{
 StarType *next; 
	
 if (ph_first) {
    ph_current = ph_first;
	while (ph_current) {
		next = ph_current -> next;
		free(ph_current);
		ph_current = next;
	}
 }
 InitStarList();
}

void AddStar(StarType **rec)
{
 StarType *s; 
	
 s = (StarType *) malloc(sizeof(StarType)); 
 s -> next = NULL;
 s -> i    = ph_nstar;
 if (ph_last==NULL) {
    ph_first = s;
    ph_last  = s;
 } else {
    ph_last -> next = s;
    ph_last = s;
 }
 *rec = s;
 ph_nstar++;
}

void FirstStar()
{
 ph_current = ph_first; 
}

int  NextStar(StarType **rec)
{
 if (ph_current!=NULL) {
	*rec = ph_current;
	ph_current = ph_current -> next;
	return 1;
 } else {
	*rec = NULL;
	return 0;
 }
}

void InitImageInfo()
{
 ph_image.ncol  = 0; 
 ph_image.nrow  = 0;
 ph_image.ccd   = NULL;
}

void ClearImageInfo()
{
 if (ph_image.ccd) free(ph_image.ccd);
}
