/**************************************************************

sort.c (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <math.h>

#include "comfun.h"
#include "robmean.h"
#include "quicksort.h"
#include "phot.h"
#include "phfun.h"

#define D(x,y)    d[((x)-1)+(((y)-1)*ncol)]

int Sorter(void)
{
	int 		i;
	StarType 	**s, *x;
	double     	*f;

	/* Reset input file */
	FirstStar();

	/* SECTION 2 - Read the input file in line by line, verbatim */
	s = (StarType **) malloc(ph_nstar*sizeof(StarType *));
	f = (double*) malloc(ph_nstar*sizeof(double));
	if ((!s)||(!f)) return MPK_MEMORY;

	i = 0;
	while (NextStar(&x)) {
		s[i] = x;
		f[i] = x->apmag[0];
		i++;
    }

    /* Perform the sort */
    QuickSortD(f, i, (void**)s);

    /* Rearanges the list of the stars */
    ph_first = NULL;
    ph_last  = NULL;
    for (i=0;i<ph_nstar;i++) {
	    s[i]->i = i;
	    if (ph_last==NULL) 
			ph_first = s[i]; 
	    else 
	        ph_last->next = s[i];
	    ph_last = s[i];
	    s[i]->next = NULL;
    }

    /* Normal return */
    free(s);
    free(f);
    return 0;
}
